<template src="./editInfoComponent.htm"></template>

<script>

    import Vue from 'vue';
    import FileComponent from '../../../../../inputs/FileComponent.vue';
    import SelectComponent from '../../../../../inputs/SelectComponent.vue';

    Vue.component('file-component', FileComponent);
    Vue.component('select-component', SelectComponent);

    export default {

        mounted() {

            eventBus.$on('entity-loaded', () => this.parseCategoryStoreObject());
        },

        data() {

            return {

                baseInfo: {

                    name: '',

                    description: '',

                    parent: null,

                    icon: {

                        file: null,

                        preview: null
                    }
                }
            }
        },

        methods: {

            parseCategoryStoreObject() {

                let category = this.$store.state.category;

                this.baseInfo.name          = category.name;
                this.baseInfo.description   = category.description;
                this.parent                 = category.parent ? category.parent.name : null;
                this.baseInfo.icon.preview  = route('images.cache', { template: category.icon.type, filename: category.icon.src });

            },

            /**
             * Assign processed file (image) to icon.
             */
            pushIcon(icon) {

                this.baseInfo.icon = icon;
            },


            /**
             * @param category
             */
            createCategoryStoreObject(category) {

                return {

                    name: category.name,

                    description: category.description,

                    parent_id: category.parent,

                    icon: category.icon.file
                }
            }
        },

        computed: {

            /**
             * Data for categories select from store getter.
             **/
            selectCategoriesList() {

                return this.$store.getters.selectCategories.filter( (el) => el.id != this.$route.params.id);
            }
        },

        watch: {

            /**
             * Push base info to store on each attribute change
             **/
            baseInfo: {

                handler(newBaseInfo) {

                    this.$store.dispatch('setCategory', this.createCategoryStoreObject(newBaseInfo));
                },

                deep: true
            }
        }
    }

</script>